Log("Scooter Lua script started")

local Scooter = {}
local jumpDust
local landDust
local gunBlast
local wheelieDust
local jumpCounter = 0.0
local jumpMove = 0.0
local landMove = 0.0
local landCounter = 0.0
local gunBlastCounter = 0.0
local wheelieDustCounter = 0.0
local onGround = false
local wheelie = false
local shootGun = false
local groundSound = -1


local headPos

function Scooter.GetTextureList()
	return "textures/Characters/Vehicles/Hog/Scooter/jumpDust.tex|textures/Characters/Vehicles/Hog/Scooter/landDust.tex|textures/Characters/Vehicles/Hog/Scooter/effect_bikeplasmagun.tex|textures/Characters/Vehicles/Hog/Scooter/effect_skidsmoke.tex"
end


function Scooter.ComponentComplete()

end

function Scooter.ConstructionComplete()
	Log("Construction!")
end


function Scooter.Init()
	OverloadVehicleSounds()
	onGround = false
	groundSound = -1
	SetHogEffects(false)
	gunBlast = LoadTexture("textures/Characters/Vehicles/Hog/Scooter/effect_bikeplasmagun.xml", 10)
	wheelieDust = LoadTexture("textures/Characters/Vehicles/Hog/Scooter/effect_skidsmoke.xml", 10)
	jumpDust = LoadTexture("textures/Characters/Vehicles/Hog/Scooter/jumpDust.xml", 10)
	landDust = LoadTexture("textures/Characters/Vehicles/Hog/Scooter/landDust.xml", 10)
	Log("Init Particles!")
end

function Scooter.PickupSequenceUpdate(dt)
	Log("PickupSequenceUpdate")
end

function Scooter.Ready(skipPickupSeq)
	Log("Ready")
end

function Scooter.Update(dt)
	if(jumpCounter > 0.0)then
		jumpCounter = jumpCounter - dt
		jumpMove = jumpMove + 3
	end	
	if(landCounter > 0.0)then
		landCounter = landCounter - dt
		landMove = landMove + 3
	end
	if(gunBlastCounter > 0.0)then
		gunBlastCounter = gunBlastCounter - dt
	end
	if(wheelieDustCounter > 0.0)then
		wheelieDustCounter = wheelieDustCounter - dt
	end
	--Log("Wheelie = "..tostring(wheelie))
	
	--Log("onGround = "..tostring(onGround))
	anim, frame = GetAnimationFrame(-1)
	if(wheelie == true and frame == 6)then
		--onGround = true
		if(groundSound == -1)then
			Log("Play Hover Engine Initially")
			groundSound = PlaySound("hover_engine_lp",true)
		end
		wheelie = false
	elseif(shootGun == true and frame == 5)then
		PlaySound("hover_gun_spin")
		shootGun = false
	end

	
end

function Scooter.Draw()
	headPos = Vector.New(GetPlayerPosition())
	if(jumpCounter > 0.0)then
		DrawTexture(jumpDust, headPos[1] + 35 - jumpMove, -80 )
	end
	if(landCounter > 0.0)then
		DrawTexture(landDust, headPos[1] + 15 - landMove, -135 )
	end
	if(gunBlastCounter > 0.0)then
		DrawTexture(gunBlast, headPos[1] + 80, headPos[2]  + 15)
	end
	if(wheelieDustCounter > 0.0)then
		DrawTexture(wheelieDust, headPos[1] - 55, headPos[2]  + 10)
	end
end


function Scooter.ShootGun()
	Log("Shoot Gun")
	PlaySound("hover_gun_fire")
	PlayAnimation(gunBlast, "fire")
	gunBlastCounter = 0.3
	shootGun = true
end

function Scooter.HitGround()
	landCounter = 0.4
	landMove = 0.0
	PlayAnimation(landDust, "land")
	PlaySound("hover_land")
	onGround = true
	if(groundSound == -1)then
		groundSound = PlaySound("hover_engine_lp",true)
	end
	Log("HitGround")
end

function Scooter.Mount()
	PlaySound("hover_start")
	wheelieDustCounter = 0.6
	PlayAnimation(wheelieDust, "mount")
	wheelie = true
end

function Scooter.TouchUp()

	inputUp = true
end

function Scooter.TouchDown()
	Log("TouchDown")

end

function Scooter.OnJump()
	StopSound(groundSound,0.1)
	groundSound = -1
	jumpCounter = 0.45
	jumpMove = 0.0
	PlayAnimation(jumpDust, "jump")
	randomJump = math.random(3)
	if(randomJump == 1)then
		PlaySound("hover_jump_1")
	elseif(randomJump == 2)then
		PlaySound("hover_jump_2")
	elseif(randomJump == 3)then
		PlaySound("hover_jump_3")
	end
	onGround = false
	shootGun = false
	inputUp = false
end

function Scooter.Explode()
	StopSound(groundSound,0.1)
	groundSound = -1
	PlaySound("hover_explode")
	Log("Explode")
end

function Scooter.Destroy(didQuit)

	Log("Destroy")

end

function LogVec(name, vec)
	Log(name..": "..vec[1]..", "..vec[2])
end

RegisterScript("Scooter", Scooter);