Log("Submarine Lua script started")

local Submarine = {}
local randomQuack
local randomLand
local quackTimer
local animationReset
local duckSlide
local duckSurface
local duckDive
local componentSound

function Submarine.GetTextureList()
	return ""
end

function Submarine.Init()
	Log("Init")
	OverloadVehicleSounds()
	OverloadPickupSounds()
	SetDrawBody(false)

	SetDrawOffset(30,2)
	animationReset = 0.0
	duckSlide = -1
	duckSurface = -1
	duckDive = -1
	componentSound = 0.0
end

function Submarine.PickupSequenceUpdate(dt)
	Log("PickupSequenceUpdate")
end

function Submarine.ComponentComplete()
	Log("Component!")
	componentSound = math.random(3)
	Log("randomQuack = "..componentSound)

	if(componentSound == 1)then
		PlaySound("duck_form_1")
	elseif(componentSound == 2)then
		PlaySound("duck_form_2")
	elseif(componentSound == 3)then
		PlaySound("duck_form_3")	
	end
	componentSound = 0
end

function Submarine.ConstructionComplete()
	Log("Construction!")
	PlaySound("duck_form_complete")
end

function Submarine.Ready(skipPickupSeq)
	Log("Ready")
end

function Submarine.Update(dt)
	
end


function Submarine.Draw()
	headPos = Vector.New(GetPlayerPosition())
	vehicleRot =  GetVehicleRotation()
	--DrawPlayer(headPos[1] - 5, headPos[2] - 7, -vehicleRot,-vehicleRot)
end

function Submarine.HitGround()
	if(duckSlide == -1)then
		duckSlide = PlaySound("duck_slide_lp", true)
	end
	Log("HitGround")
end

function Submarine.LeaveGround()
	StopSound(duckSlide,0.2)
	duckSlide = -1
	Log("LeaveGround")
end

function Submarine.Dive()
	StopSound(duckSurface,0.2)
	duckSurface = -1
	if(duckDive == -1)then
		duckDive = PlaySound("duck_underwater_lp", true)
	end
	Log("Dive")
end

function Submarine.Surface()
	StopSound(duckDive,0.2)
	duckDive = -1
	if(duckSurface == -1)then
		duckSurface = PlaySound("duck_surface_lp", true)
	end
	PlaySound("duck_jump")
	Log("Surface")
end

function Submarine.Airbourne()
	StopSound(duckSurface,0.2)
	duckSurface = -1
	StopSound(duckDive,0.2)
	duckDive = -1
	PlaySound("duck_jump")
	quackTimer = 0.1
	Log("Airbourne")
end

function Submarine.HitWater()
	if(duckSurface == -1)then
		duckSurface = PlaySound("duck_surface_lp", true)
	end
	Log("duckSurface = "..duckSurface)
	
	randomLand = math.random(4)
	if(randomLand == 1)then
		PlaySound("duck_land")
	elseif(randomLand == 2)then
		PlaySound("duck_land_1")
	elseif(randomLand == 3)then
		PlaySound("duck_land_2")
	elseif(randomLand == 4)then
		PlaySound("duck_land_3")
	end
	
	randomLand = 0
	
	Log("HitWater")
end

function Submarine.TouchUp()
	inputUp = true
end

function Submarine.TouchDown()
	inputUp = false
end

function Submarine.Explode()
	PlaySound("duck_explode")
	PlaySound("duck_impact")
	StopSound(duckDive,0.2)
	duckDive = -1
	StopSound(duckSlide,0.2)
	duckSlide = -1
	StopSound(duckSurface,0.2)
	duckSurface = -1
	Log("Explode")
end

function Submarine.Destroy(didQuit)

	Log("Destroy")
end

function LogVec(name, vec)
	Log(name..": "..vec[1]..", "..vec[2])
end


RegisterScript("Submarine", Submarine);